//**************************************************************//
//  Effect File exported by RenderMonkey 1.6
//
//  - Although many improvements were made to RenderMonkey FX  
//    file export, there are still situations that may cause   
//    compilation problems once the file is exported, such as  
//    occasional naming conflicts for methods, since FX format 
//    does not support any notions of name spaces. You need to 
//    try to create workspaces in such a way as to minimize    
//    potential naming conflicts on export.                    
//    
//  - Note that to minimize resulting name collisions in the FX 
//    file, RenderMonkey will mangle names for passes, shaders  
//    and function names as necessary to reduce name conflicts. 
//**************************************************************//

//--------------------------------------------------------------//
// ColorConversion
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// EnvironmentMapping
//--------------------------------------------------------------//
string ColorConversion_EnvironmentMapping_Model : ModelData = "C:\\Program Files (x86)\\AMD\\RenderMonkey 1.82\\Examples\\Media\\Models\\Teapot.3ds";

float4x4 gWorldMat : World;
float4x4 gWorldViewProjMat : WorldViewProjection;

float4 gLightPos
<
   string UIName = "gLightPos";
   string UIWidget = "Direction";
   bool UIVisible =  false;
   float4 UIMin = float4( -10.00, -10.00, -10.00, -10.00 );
   float4 UIMax = float4( 10.00, 10.00, 10.00, 10.00 );
   bool Normalize =  false;
> = float4( 500.00, 500.00, -500.00, 1.00 );
float4 gViewPos : ViewPosition;

struct VS_INPUT 
{
   float4 pos : POSITION;
   float3 normal : NORMAL;
   float2 uv : TEXCOORD0;
   float3 tangent : TANGENT;
   float3 binoraml : BINORMAL;
};

struct VS_OUTPUT 
{
   float4 pos : POSITION;
   float2 uv : TEXCOORD0;
   float3 lightDir : TEXCOORD1;
   float3 viewDir : TEXCOORD2;
   float3 T : TEXCOORD3;
   float3 B : TEXCOORD4;
   float3 N : TEXCOORD5;
};

VS_OUTPUT ColorConversion_EnvironmentMapping_Vertex_Shader_vs_main( VS_INPUT input )
{
   VS_OUTPUT output;

   output.pos = mul( input.pos, gWorldViewProjMat);
   
   output.uv = input.uv;
   
   float4 worldPos = mul( input.pos, gWorldMat);
   
   float3 lightDir = worldPos - gLightPos.xyz;
   output.lightDir = normalize( lightDir);
   
   float3 viewDir = worldPos - gViewPos.xyz;
   output.viewDir = normalize( viewDir);
   
   float3 worldNormal = mul( input.normal, (float3x3)gWorldMat);
   output.N = normalize( worldNormal);
   
   float3 worldTangent = mul( input.tangent, (float3x3)gWorldMat);
   output.T = normalize( worldTangent);
   
   float3 worldBinormal = mul( input.binoraml, (float3x3)gWorldMat);
   output.B = normalize( worldBinormal);
   
   return output;   
}




texture DiffuseMap_Tex
<
   string ResourceName = "C:\\Program Files (x86)\\AMD\\RenderMonkey 1.82\\Examples\\Media\\Textures\\Fieldstone.tga";
>;
sampler2D DiffuseSampler = sampler_state
{
   Texture = (DiffuseMap_Tex);
};
texture SpecularMap_Tex
<
   string ResourceName = ".\\fieldstone_SM.tga";
>;
sampler2D SpecularSampler = sampler_state
{
   Texture = (SpecularMap_Tex);
};
sampler2D NormalSampler;
texture EnvironmentMap_Tex
<
   string ResourceName = "C:\\Program Files (x86)\\AMD\\RenderMonkey 1.82\\Examples\\Media\\Textures\\Snow.dds";
>;
samplerCUBE EnvironmentSampler = sampler_state
{
   Texture = (EnvironmentMap_Tex);
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
};

struct PS_INPUT 
{
   float2 uv : TEXCOORD0;
   float3 lightDir : TEXCOORD1;
   float3 viewDir : TEXCOORD2;
   float3 T : TEXCOORD3;
   float3 B : TEXCOORD4;
   float3 N : TEXCOORD5;
};

float3 gLightColor
<
   string UIName = "gLightColor";
   string UIWidget = "Numeric";
   bool UIVisible =  false;
   float UIMin = -1.00;
   float UIMax = 1.00;
> = float3( 0.70, 0.70, 1.00 );

float4 ColorConversion_EnvironmentMapping_Pixel_Shader_ps_main( PS_INPUT input) : COLOR
{
   float3 tangentNormal = tex2D( NormalSampler, input.uv).xyz;
   tangentNormal = normalize( tangentNormal * 2 - 1);
   
   //for test environment map
   tangentNormal = float3( 0, 0, 1);  
   
   float3x3 TBN = float3x3( normalize( input.T), 
                            normalize( input.B),
                            normalize( input.N));

   TBN = transpose( TBN);
   float3 worldNormal = mul( TBN, tangentNormal);
     
   float4 albedo = tex2D(DiffuseSampler, input.uv); 
   float3 lightDir = normalize( input.lightDir);
   float3 diffuse = saturate( dot( worldNormal, -lightDir));
   diffuse = gLightColor * albedo.rgb * diffuse;
      
   float3 specular = 0;
   
   float3 viewDir = normalize( input.viewDir);
   
   if( diffuse.x > 0)
   {
      float3 reflection = reflect( lightDir, worldNormal);
            
      specular = dot( reflection, -viewDir);
      specular = saturate( specular);
      
      specular = pow( specular, 20);
      
      float4 specularIntensity = tex2D(SpecularSampler, input.uv);
      specular = gLightColor * specularIntensity.rgb * specular;
   }
   float3 viewReflect = reflect( viewDir, worldNormal);
   float3 environment = texCUBE( EnvironmentSampler, viewReflect).rgb;
   
   float3 ambient = float3( 0.1f, 0.1f, 0.1f) * albedo;
   
   return float4( ambient + specular + diffuse + environment*0.5f, 1.0f); 
}




//--------------------------------------------------------------//
// Technique Section for ColorConversion
//--------------------------------------------------------------//
technique ColorConversion
{
   pass EnvironmentMapping
   {
      VertexShader = compile vs_2_0 ColorConversion_EnvironmentMapping_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 ColorConversion_EnvironmentMapping_Pixel_Shader_ps_main();
   }

}

