//ArcBall.h
#ifndef _ARCBALL
#define _ARCBALL

#include <d3dx9.h>

class ArcBall
{
public:
	ArcBall(void);
	~ArcBall(void);

public:
	void Reset() ;
	void OnBegin(int mousex, int mousey);
	void OnMove(int mousex, int mousey);
	void OnEnd();

	D3DXQUATERNION QuatFromBallPoints(D3DXVECTOR3& startPoint, D3DXVECTOR3& endPoint);
	const D3DXMATRIX* GetRotationMatrix();
	D3DXQUATERNION GetRotationQuatIncreament();
	void SetWindow(int windowWidth, int windowHeight, float arcballRadius = 1.0f);

	int GetWindowWidth() { return mWindowWidth; }
	int GetWindowHeight() { return mWindowHeight; }

private:
	int		mWindowWidth;	 // arc ball's window width
	int		mWindowHeight; // arc ball's window height
	float	mRadius;	     // arc ball's radius in screen coordinates
	bool	mIsDragged;	 // whether the arc ball is dragged

	D3DXQUATERNION	mPreviousQuaternion;	// quaternion before mouse down
	D3DXQUATERNION	mCurrentQuaternion;	// current quaternion
	D3DXQUATERNION	mRotationIncreament;	// rotation increment 
	D3DXVECTOR3		mPreviousPoint;		// starting point of arc ball rotate
	D3DXVECTOR3		mCurrentPoint;		// current point of arc ball rotate
	D3DXVECTOR3		mOldPoint;			// old point 
	D3DXMATRIXA16	mRotateMat;			// rotation matrix

	// Convert scree point to arcball point(vector)
	D3DXVECTOR3	ScreenToVector(int fScreenPtX, int fScreenPtY);
};

#endif